﻿using Dapper;
using ExchangeService.Client.Models;
using ExchangeService.GrpcServer;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Serilog;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reactive.Linq;
using System.Threading.Tasks;

namespace DicomTransferFileApi.Client.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class FindDicomFileController : ControllerBase
    {


        private readonly IConfiguration configuration;

        public FindDicomFileController(IConfiguration config)
        {
            configuration = config;
        }

        [HttpPost]
        public async Task<List<DicomFilesTransferModel>> Post([FromForm]ExchangeService.Client.Models.FilesPackage inputsDto)
        {
            Log.Information("FindDicomFile Started ...!");
            string connectionString = configuration != null ? configuration.GetConnectionString("DefaultConnection") :
                "Data Source=localhost;Integrated Security=SSPI;Initial Catalog=mv";
            string view = configuration != null ? configuration["Views:ImageDetails"] : "vw_image_details";
            List<ImageDetails> imageDetailsList = new List<ImageDetails>();

            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                var query = connection.Query<ImageDetails>
                ($"SELECT *  from {view} "
                    + $"where [StudyInstanceUID] = '{inputsDto.StudyInstanceUID}'").ToList();
                imageDetailsList.AddRange(query);
            }

            List<DicomFilesTransferModel> uploadedFiles = new List<DicomFilesTransferModel>();
            if (imageDetailsList!.Count > 0 && imageDetailsList.Select(f => f.File).Count() > 0)
            {
                imageDetailsList.ToObservable().Select(f => f.File).Subscribe(f =>
                {
                    uploadedFiles.Add(new DicomFilesTransferModel
                    {
                        UploadedFile = f
                    });
                });

                return uploadedFiles;
            }
            return null;
        }
    }
}
