using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ExchangeService.Client.SerilogConfig;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using Serilog;

namespace ExchangeService.Client
{
    public class Program
    {
        public static void Main(string[] args)
        {

            var resp = SeriLogConfig.LoggerConfiguration(Serilog.Events.LogEventLevel.Debug);
            if (!resp.Result)
            {
                Console.WriteLine(resp.Log);
                return;
            }



            SeriLogConfig.LoggerConfiguration(Serilog.Events.LogEventLevel.Information);
            Log.Information("Starting ExchangeService.Client ...");

            CreateHostBuilder(args).Build().Run();
        }

        public static IHostBuilder CreateHostBuilder(string[] args) =>
            Host.CreateDefaultBuilder(args)
                .ConfigureWebHostDefaults(webBuilder =>
                {
                    webBuilder.UseStartup<Startup>();
                });
    }
}
