using System;
using System.Threading.Tasks;
using Dicom.Network;
using Grpc.Core;
using Microsoft.Extensions.Logging;
using Serilog;
using DicomClient = Dicom.Network.Client.DicomClient;

namespace ExchangeService.GrpcServer
{
    public class DicomFileOperationService : DicomOps.DicomOpsBase
    {
        public override async Task TransferDicomFiles(DicomFilesTransferModel request,
            IServerStreamWriter<DicomFilesTransferResponse> responseStream,
            ServerCallContext context)
        {

            Log.Information("DicomTransferFile Started ...!");
            var client = new DicomClient("127.0.0.1", 104, false, "MARCO", "ANY-SCP");
            //var client = new DicomClient(request.ServerHost, request.Port, false, request.ServerAET, request.Aet);
            client.NegotiateAsyncOps();

            try
            {
                var requests = new DicomCStoreRequest(request.UploadedFile);
                await client.AddRequestAsync(requests);
                await client.SendAsync();
                await responseStream.WriteAsync(new DicomFilesTransferResponse() { Message = $" {request.UploadedFile}  file Send" });
                Log.Information($" {request.UploadedFile}  file Send" );
            }
            catch (Exception ex)
            {

                Log.Information(ex.Message);
                await responseStream.WriteAsync(new DicomFilesTransferResponse() { Message = ex.Message });
            }

            Log.Information("DicomTransferFile Finished ...!");
        }
    }
}
